# SmallOverlap GAP Package
# Copyright (C) 2007-2008 Mark Kambites, University of Manchester
#
# This package contains code for manipulating semigroups and monoids with
# presentations satisfying small overlap conditions of the kind
# introduced by Remmers.  The algorithms used are described in the paper
# M. Kambites, "Small overlap monoids: the word problem", arXiv ref.
#
# This file contains only declarations - for comments describing the things
# declared see the appropriate .gi files.

DeclareProperty("IsFpMonoidOrSemigroup", IsObject);
DeclareProperty("IsElementOfFpMonoidOrSemigroup", IsObject);

DeclareAttribute("RelationWords", IsFpMonoidOrSemigroup);
DeclareAttribute("MaxPiecePrefixLengths", IsFpMonoidOrSemigroup);
DeclareAttribute("MaxPieceSuffixLengths", IsFpMonoidOrSemigroup);
DeclareAttribute("RelationWordLengths", IsFpMonoidOrSemigroup);
DeclareAttribute("MiddleWordLengths", IsFpMonoidOrSemigroup);
DeclareAttribute("MaxPieceSuffixLengthBound", IsFpMonoidOrSemigroup);
DeclareAttribute("MaxCommonSuffixLengthOfRelationWords", IsFpMonoidOrSemigroup);

DeclareAttribute("SmallOverlapClass", IsFpMonoidOrSemigroup);

DeclareProperty("IsC4", IsFpMonoidOrSemigroup);
DeclareProperty("IsC3", IsFpMonoidOrSemigroup);
DeclareProperty("IsC2", IsFpMonoidOrSemigroup);
DeclareProperty("IsC1", IsFpMonoidOrSemigroup);

DeclareProperty("IsElementOfC4", IsElementOfFpMonoidOrSemigroup);
DeclareProperty("IsElementOfC3", IsElementOfFpMonoidOrSemigroup);
DeclareProperty("IsElementOfC2", IsElementOfFpMonoidOrSemigroup);
DeclareProperty("IsElementOfC1", IsElementOfFpMonoidOrSemigroup);

DeclareGlobalFunction("LengthLongestPieceFactorToRight");
DeclareGlobalFunction("LengthLongestPieceFactorToLeft");
DeclareGlobalFunction("C4WordProblem");
DeclareGlobalFunction("C4WordProblemReckless");
DeclareGlobalFunction("CleanOverlapPrefix");
DeclareGlobalFunction("RelationPrefix");
DeclareGlobalFunction("IsFactorAt");
DeclareGlobalFunction("FirstRelationPrefixPosition");
DeclareGlobalFunction("MaxCommonSuffixLength");
DeclareGlobalFunction("CompareFactors");
DeclareGlobalFunction("WriteMaxPieceSuffixInList");
DeclareGlobalFunction("ComplementRelationWord");
DeclareGlobalFunction("IsPrefixActive");
DeclareGlobalFunction("PreferSmallOverlapEqualityTest");
